#include <cvirte.h>
#include "mc4self.h"
#include "test.h"
#include <ansi_c.h>


int handle;
int result = 0;
int card = 0;
unsigned int AnzAdKanaele = 1;
unsigned int Abtastrate = 300;
unsigned int AnzWertePerCh = 100;
int AnzErfasstWerteAD;
int WerteZaehlerAD = 0;
double *WertePufferAD;
double *datapoints;
int Status = 0;



int main (int argc, char *argv[])
{
	
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;

    handle = LoadPanel (0, "test.uir", PANEL);									// Die graphische Oberflche laden
    DisplayPanel (handle);														// und darstellen
	result = LoadMC4SelfDll();													// Die DLL mc4self.dll laden
    RunUserInterface();

	return 0;
}




int  CVICALLBACK StartCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int i;
	i = VAL_RED;
	i = VAL_GREEN;
    if (event == EVENT_COMMIT && Status == 0)
    {
    	Status = 1;																// Status = 1 - Messung luft
    	result = OpenCard(card);												// Verbindung zu der Messkarte aufbauen
    	result = ClearChannelLists();											// Die Kanalliste zurcksetzen

		GetCtrlVal(handle, PANEL_ABTASTRATE, &Abtastrate);						// Die Abtastrate von der Oberflche lesen
		GetCtrlVal(handle, PANEL_CHANNELS, &AnzAdKanaele);						// Anzahl der eingestellten analogen Kanle von der Oberflch lesen
		GetCtrlVal(handle, PANEL_BLOCKSIZE, &AnzWertePerCh);					// Die Blockgr der Messwerte von der Oberflche lesen
		
		SetCtrlVal (handle, PANEL_Anzeige, (double)WerteZaehlerAD);				// Anzahl der erfassten Messwerte auf der Oberflche zurcksetzen

		for ( i=0; i<AnzAdKanaele; i++)											// Schleife ber der Kanalliste
		{																		// Kanalliste programmieren
			result = Add_AD_Channel_to_ScanList( i,								// Kanalnumer des analogen Kanals
												 0,								// Oversampling (nicht untersttzt auf der Basic Serie)
												 0,								// Verstrkung
												 1								// Bipolar (Basic Serie untersttzt nur den Bipolarmodus )
												);
																
		}
    	
		result = SetADFrequency ( Abtastrate );									// Abtastrate Programmieren (in Herz)
		result = FinalInit();													// Die vorgenommenen Einstellungen der Kanalliste 
																				// und der Abtastrate auf die Messkarte bertragen
		result = StartADCapture();												// Start der analogen Messung

		datapoints = (double*)malloc( AnzWertePerCh * sizeof(double) );			// Speicher die Anzeige der analogen Messwerte reservieren
    	
		WertePufferAD = (double*)malloc( AnzAdKanaele * AnzWertePerCh * sizeof(double));// Speicher fr die Messwerte der analogen Messung reservieren

    	SetCtrlAttribute (handle, PANEL_TIMER, ATTR_ENABLED, 1);				// Den Teimer aktivieren, die Teimerfunktion beinhaltet die Erfassungsfunktionen
    }

	return 0;
}




int  CVICALLBACK TimerCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int i, j, color;
	
	if (event == EVENT_TIMER_TICK)
	{   
		AnzErfasstWerteAD = AnzWertePerCh;										// Anzahl der zu holenden Messwerte fetlegen
		
		
		// Die Gre des reservierten Speichers betrgt (AnzKanaele * AnzWertePerCh * sizeof(double) )
		// Die erfasten Messwerte werden wie folgt in den reservierten Speicherbereih bertragen:
		// Wert0_Kanal0, Wert0_Kanal1, Wert0_Kanal2... Wert1_Kanal0, Wert1_Kanal1, Wert1_Kanal2 usw.

		// Mit dem Aufruf von GetScaledData werden die Messwerte von der 
		// Messkarte in den reservierten Speicher des Messprogremms bertragen
		result = GetScaledData( 2,												// InputRange = 2(-10..+10Volt)
								WertePufferAD,									// Zeiger auf den reservierten Speicherbereich in den die Messwerte bertragen werden 
								&AnzErfasstWerteAD,								// Zeiger auf die Variable mit der Angaben der Anzahl zu bertragenden Messwerte pro Kanal,
																				// zurckgegeben wird die Anzahl der tatschlich erfassten Messwerte
								1												// SkipIfLessData (bei 1 - wen die Anzahl der erfassten Messwerte >= Anzahl der zu holenden Werte, werden die Messwerte bertragen,
																				// sonst werden keine Messwerte bertraagen)
																				// (bei 0 - wird immer die Anzahl der gerade zur bertragung vorliegenden Messwerte bertragen)
							  );

		if (AnzErfasstWerteAD > 0)
		{
			WerteZaehlerAD = WerteZaehlerAD + AnzErfasstWerteAD;				// Den Wertezhler erhhen

	        SetCtrlVal (handle, PANEL_Anzeige, (double)WerteZaehlerAD);			// Den Zhler der erfassten Werte auf dem Bildschirm ausgeben

			DeleteGraphPlot (handle, PANEL_GRAPH, -1, 1);
			for ( j=0; j<AnzAdKanaele; j++)										// Schleife ber die Anzahl der Kanle
			{
				for ( i=0; i< AnzErfasstWerteAD; i++)							// Schleife ber die Anzahl der Erfassten Messwerte pro Kanal
				{
					datapoints[i] = WertePufferAD[(i * AnzAdKanaele) + j];		// Werte kanalweise aussortieren
				}
				switch(j)														// Kurvenfarbe kanalweise festlegen
				{
					case 0:
						color = VAL_WHITE;
						break;
					case 1:
						color = VAL_RED;
						break;
					case 2:
						color = VAL_GREEN;
						break;
					case 3:
						color = VAL_BLUE;
						break;
					case 4:
						color = VAL_YELLOW;
						break;
					case 5:
						color = VAL_MAGENTA;
						break;
					case 6:
						color = VAL_CYAN;
						break;
					default:
						color = VAL_WHITE;
				}
				
	            PlotY (handle, PANEL_GRAPH, datapoints, AnzWertePerCh, 			// Messwerte fr ein Kanal auf der Anzeige Ausgeben
	               VAL_DOUBLE, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, color);
			}
		}
	}
	
	
	
	return 0;
}




int  CVICALLBACK StopCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
    if (event == EVENT_COMMIT && Status == 1 )
    {
    	Status = 0;																// Status = 0 - Messung ist gestoppt
    	SetCtrlAttribute (handle, PANEL_TIMER, ATTR_ENABLED, 0);				// Teimer zurcksetzen
    	Sleep(50);																// Abwarten bis die Timerfunktion deren letzte Handlung abgeschloen hat.
		result = StopADCapture();												// Die analoge Erfassung stoppen
		free(WertePufferAD);													// Den reservierten Speicher der analogen Messwerte freigeben
		free(datapoints);														// Den reservierten Speicher freigeben
		WerteZaehlerAD = 0;														// Wertezhler auf 0 setzen
		
		result = CloseCard(card);												// Die Verbindung zu der Karte freigeben
    }

	return 0;
}




int  CVICALLBACK QuitCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
    if (event == EVENT_COMMIT)
    {
		result = StopADCapture();												// Die analoge Erfassung stoppen
		result = CloseCard(card);												// Die Verbindung zu der Karte freigeben
		CloseMC4SelfDll();														// Die DLL mc4Self.dll freigeben
		QuitUserInterface(0);													// Die Oberflche schlieen
    }
        
    return 0;
}
